        subroutine backtrans(nd,nt,x,y)
c backward wavelet transform
c nd: length of data set
c nt length of data in data set to be transformed
c m filter length (m has to be even!)
c x input data, y output data
        implicit real*8 (a-h,o-z)
        dimension x(0:nd-1),y(0:nd-1)
c include the approriate filter coefficients
        include 'filters.inc'

        do 100,i=0,nt/2-1
        y(2*i+0)=0.d0
        y(2*i+1)=0.d0

        do 50,j=-m/2,m/2-1

c periodically wrap index if necessary
        ind=i-j
99      continue
        if (ind.lt.0) then
        ind=ind+nt/2
        goto 99
        endif
        if (ind.ge.nt/2) then
        ind=ind-nt/2
        goto 99
        endif

        y(2*i+0)=y(2*i+0) + ch(2*j-0)*x(ind)+cg(2*j-0)*x(ind+nt/2)
        y(2*i+1)=y(2*i+1) + ch(2*j+1)*x(ind)+cg(2*j+1)*x(ind+nt/2)
50      continue

100     continue

        return
        end

C Identical to the homonymous subroutine of Goedecker (1998), except
C that additional .inc files are included through filters.inc.
