      subroutine denoise_g1d(cha_ct,cha_sd,cha_t,cha_tn,nd,nt_min,sigma,
     +                       t,x,y)
C***********************************************************************

      character*3
     +          cha_ct,
     +          cha_sd,
     +          cha_t,
     +          cha_tn

      integer   i,
     +          i_0,
     +          nd,
     +          nt_min

      real*8    data(0:nd/2-1),
     +          median,
     +          sigma,
     +          t,
     +          x(0:nd-1),
     +          xy(0:nd-1),
     +          y(0:nd-1)

C-----------------------------------------------------------------------

      call fwt_1df(nd,nt_min,x,xy)
      if (cha_sd.eq.'ng') then
         do i=nd/2,nd-1
            data(i-nd/2)=abs(xy(i))
         enddo
         sigma=1.d0/.6745d0*median(nd/2,data)
      elseif (cha_sd.eq.'g') then
         sigma=1.d0
      endif
      if (cha_t.eq.'h') then
         t=sigma*sqrt(2.d0*log(dble(nd)))
      elseif (cha_t.eq.'l') then
         if (nd.le.32) then
            t=sigma*0.d0
         else
            t=sigma*(.3936d0+.1829d0*log(dble(nd))/log(2.d0))
         endif
      endif
      if (cha_ct.eq.'d') then
         i_0=nt_min/2
      elseif (cha_ct.eq.'a&d') then
         i_0=0
      endif
      do i=i_0,nd-1
         if (cha_tn.eq.'h') then
            if (abs(xy(i)).le.t) then
               xy(i)=0.d0
            endif
         elseif (cha_tn.eq.'s') then
            if (abs(xy(i)).le.t) then
               xy(i)=0.d0
            else
               xy(i)=sign(abs(xy(i))-t,xy(i))
            endif
         endif
      enddo
      call fwt_1db(nd,nt_min,xy,y)

      return
      end
