      subroutine denoise_p2d(cha_ct,cha_sd,cha_t,cha_tn,nd,nt_min,bias,
     +                       sigma,t,x,y)
C***********************************************************************

      character*3
     +          cha_ct,
     +          cha_sd,
     +          cha_t,
     +          cha_tn

      integer   i,
     +          j,
     +          nd,
     +          nt_min

      real*8    bias,
     +          sigma,
     +          t,
     +          x(0:nd-1,0:nd-1),
     +          xx(0:nd-1,0:nd-1),
     +          y(0:nd-1,0:nd-1)

C-----------------------------------------------------------------------

      do j=0,nd-1
         do i=0,nd-1
            xx(i,j)=2.d0*sqrt(x(i,j)+3.d0/8.d0)
         enddo
      enddo
      call denoise_g2d(cha_ct,cha_sd,cha_t,cha_tn,nd,nt_min,sigma,t,xx,
     +                 y)
      bias=-1.d0/4.d0*(1.d0-1.d0/dble(nd**2))*sigma**2
      do j=0,nd-1
         do i=0,nd-1
            y(i,j)=1.d0/4.d0*y(i,j)**2-3.d0/8.d0-bias
         enddo
      enddo

      return
      end
