      subroutine denoise_p3d(cha_ct,cha_sd,cha_t,cha_tn,nd,nt_min,bias,
     +                       sigma,t,x,y)
C***********************************************************************

      character*3
     +          cha_ct,
     +          cha_sd,
     +          cha_t,
     +          cha_tn

      integer   i,
     +          j,
     +          k,
     +          nd,
     +          nt_min

      real*8    bias,
     +          sigma,
     +          t,
     +          x(0:nd-1,0:nd-1,0:nd-1),
     +          xx(0:nd-1,0:nd-1,0:nd-1),
     +          y(0:nd-1,0:nd-1,0:nd-1)

C-----------------------------------------------------------------------

      do k=0,nd-1
         do j=0,nd-1
            do i=0,nd-1
               xx(i,j,k)=2.d0*sqrt(x(i,j,k)+3.d0/8.d0)
            enddo
         enddo
      enddo
      call denoise_g3d(cha_ct,cha_sd,cha_t,cha_tn,nd,nt_min,sigma,t,xx,
     +                 y)
      bias=-1.d0/4.d0*(1.d0-1.d0/dble(nd**3))*sigma**2
      do k=0,nd-1
         do j=0,nd-1
            do i=0,nd-1
               y(i,j,k)=1.d0/4.d0*y(i,j,k)**2-3.d0/8.d0-bias
            enddo
         enddo
      enddo

      return
      end
