      subroutine denoise_p3ds(cha_ct,cha_sd,cha_t,cha_tn,nd1,nd2,nd3,
     +                        nt_min1,nt_min2,nt_min3,bias,sigma,t,x,y)
C***********************************************************************

      character*3
     +          cha_ct,
     +          cha_sd,
     +          cha_t,
     +          cha_tn

      integer   i1,
     +          i2,
     +          i3,
     +          nd1,
     +          nd2,
     +          nd3,
     +          nt_min1,
     +          nt_min2,
     +          nt_min3

      real*8    bias,
     +          sigma,
     +          t,
     +          x(0:nd1-1,0:nd2-1,0:nd3-1),
     +          xx(0:nd1-1,0:nd2-1,0:nd3-1),
     +          y(0:nd1-1,0:nd2-1,0:nd3-1)

C-----------------------------------------------------------------------

      do i3=0,nd3-1
         do i2=0,nd2-1
            do i1=0,nd1-1
               xx(i1,i2,i3)=2.d0*sqrt(x(i1,i2,i3)+3.d0/8.d0)
            enddo
         enddo
      enddo
      call denoise_g3ds(cha_ct,cha_sd,cha_t,cha_tn,nd1,nd2,nd3,nt_min1,
     +                  nt_min2,nt_min3,sigma,t,xx,y)
      bias=-1.d0/4.d0*(1.d0-1.d0/dble(nd1*nd2*nd3))*sigma**2
      do i3=0,nd3-1
         do i2=0,nd2-1
            do i1=0,nd1-1
               y(i1,i2,i3)=1.d0/4.d0*y(i1,i2,i3)**2-3.d0/8.d0-bias
            enddo
         enddo
      enddo

      return
      end
