      subroutine denoise_sg2d(cha_sd,cha_t,nd,nt_min,c,sigma,t,x,y)
C***********************************************************************

      character*3
     +          cha_sd,
     +          cha_t

      integer   i,
     +          j,
     +          nd,
     +          nt_min

      real*8    c,
     +          data(0:3*nd**2/4-1),
     +          median,
     +          sigma,
     +          t,
     +          x(0:nd-1,0:nd-1),
     +          xy(0:nd-1,0:nd-1),
     +          y(0:nd-1,0:nd-1)

C-----------------------------------------------------------------------

      call fwt_2df(nd,nt_min,x,xy)
      if (cha_sd.eq.'ng') then
         do j=0,nd/2-1
            do i=nd/2,nd-1
               data(i+j*nd/2-nd/2)=abs(xy(i,j))
            enddo
         enddo
         do j=nd/2,nd-1
            do i=0,nd-1
               data(i+j*nd-nd**2/4)=abs(xy(i,j))
            enddo
         enddo
         sigma=1.d0/.6745d0*median(3*nd**2/4,data)
      elseif (cha_sd.eq.'g') then
         sigma=1.d0
      endif
      if (cha_t.eq.'h') then
         t=sigma*sqrt(2.d0*log(dble(nd**2)))
      elseif (cha_t.eq.'l') then
         if (nd**2.le.32) then
            t=sigma*0.d0
         else
            t=sigma*(.3936d0+.1829d0*log(dble(nd**2))/log(2.d0))
         endif
      endif
      do j=0,nt_min/2-1
         do i=nt_min/2,nd-1
            if (abs(xy(i,j)).le.t) then
               xy(i,j)=c*xy(i,j)
            endif
         enddo
      enddo
      do j=nt_min/2,nd-1
         do i=0,nd-1
            if (abs(xy(i,j)).le.t) then
               xy(i,j)=c*xy(i,j)
            endif
         enddo
      enddo
      call fwt_2db(nd,nt_min,xy,y)

      return
      end
