      subroutine denoise_sp2d(cha_sd,cha_t,nd,nt_min,bias,c,sigma,t,x,y)
C***********************************************************************

      character*3
     +          cha_sd,
     +          cha_t

      integer   i,
     +          j,
     +          nd,
     +          nt_min

      real*8    bias,
     +          c,
     +          sigma,
     +          t,
     +          x(0:nd-1,0:nd-1),
     +          x_mean,
     +          x_tot,
     +          xx(0:nd-1,0:nd-1),
     +          y(0:nd-1,0:nd-1),
     +          y_mean,
     +          y_tot

C-----------------------------------------------------------------------

      do j=0,nd-1
         do i=0,nd-1
            xx(i,j)=2.d0*sqrt(x(i,j)+3.d0/8.d0)
         enddo
      enddo
      call denoise_sg2d(cha_sd,cha_t,nd,nt_min,c,sigma,t,xx,y)
      do j=0,nd-1
         do i=0,nd-1
            y(i,j)=1.d0/4.d0*y(i,j)**2-3.d0/8.d0
         enddo
      enddo
      do j=0,nd-1
         do i=0,nd-1
            if (y(i,j).lt.0.d0) then
               y(i,j)=0.d0
            endif
         enddo
      enddo
      x_tot=0.d0
      y_tot=0.d0
      do j=0,nd-1
         do i=0,nd-1
            x_tot=x_tot+x(i,j)
            y_tot=y_tot+y(i,j)
         enddo
      enddo
      x_mean=x_tot/dble(nd**2)
      y_mean=y_tot/dble(nd**2)
      bias=y_mean-x_mean
      do j=0,nd-1
         do i=0,nd-1
            y(i,j)=y(i,j)-bias
         enddo
      enddo

      return
      end
