      subroutine denoise_sp3d(cha_sd,cha_t,nd,nt_min,bias,c,sigma,t,x,y)
C***********************************************************************

      character*3
     +          cha_sd,
     +          cha_t

      integer   i,
     +          j,
     +          k,
     +          nd,
     +          nt_min

      real*8    bias,
     +          c,
     +          sigma,
     +          t,
     +          x(0:nd-1,0:nd-1,0:nd-1),
     +          x_mean,
     +          x_tot,
     +          xx(0:nd-1,0:nd-1,0:nd-1),
     +          y(0:nd-1,0:nd-1,0:nd-1),
     +          y_mean,
     +          y_tot

C-----------------------------------------------------------------------

      do k=0,nd-1
         do j=0,nd-1
            do i=0,nd-1
               xx(i,j,k)=2.d0*sqrt(x(i,j,k)+3.d0/8.d0)
            enddo
         enddo
      enddo
      call denoise_sg3d(cha_sd,cha_t,nd,nt_min,c,sigma,t,xx,y)
      do k=0,nd-1
         do j=0,nd-1
            do i=0,nd-1
               y(i,j,k)=1.d0/4.d0*y(i,j,k)**2-3.d0/8.d0
            enddo
         enddo
      enddo
      do k=0,nd-1
         do j=0,nd-1
            do i=0,nd-1
               if (y(i,j,k).lt.0.d0) then
                  y(i,j,k)=0.d0
               endif
            enddo
         enddo
      enddo
      x_tot=0.d0
      y_tot=0.d0
      do k=0,nd-1
         do j=0,nd-1
            do i=0,nd-1
               x_tot=x_tot+x(i,j,k)
               y_tot=y_tot+y(i,j,k)
            enddo
         enddo
      enddo
      x_mean=x_tot/dble(nd**3)
      y_mean=y_tot/dble(nd**3)
      bias=y_mean-x_mean
      do k=0,nd-1
         do j=0,nd-1
            do i=0,nd-1
               y(i,j,k)=y(i,j,k)-bias
            enddo
         enddo
      enddo

      return
      end
