      subroutine denoise_sp3ds(cha_sd,cha_t,nd1,nd2,nd3,nt_min1,nt_min2,
     +                         nt_min3,bias,c,sigma,t,x,y)
C***********************************************************************

      character*3
     +          cha_sd,
     +          cha_t

      integer   i1,
     +          i2,
     +          i3,
     +          nd1,
     +          nd2,
     +          nd3,
     +          nt_min1,
     +          nt_min2,
     +          nt_min3

      real*8    bias,
     +          c,
     +          sigma,
     +          t,
     +          x(0:nd1-1,0:nd2-1,0:nd3-1),
     +          x_mean,
     +          x_tot,
     +          xx(0:nd1-1,0:nd2-1,0:nd3-1),
     +          y(0:nd1-1,0:nd2-1,0:nd3-1),
     +          y_mean,
     +          y_tot

C-----------------------------------------------------------------------

      do i3=0,nd3-1
         do i2=0,nd2-1
            do i1=0,nd1-1
               xx(i1,i2,i3)=2.d0*sqrt(x(i1,i2,i3)+3.d0/8.d0)
            enddo
         enddo
      enddo
      call denoise_sg3ds(cha_sd,cha_t,nd1,nd2,nd3,nt_min1,nt_min2,
     +                   nt_min3,c,sigma,t,xx,y)
      do i3=0,nd3-1
         do i2=0,nd2-1
            do i1=0,nd1-1
               y(i1,i2,i3)=1.d0/4.d0*y(i1,i2,i3)**2-3.d0/8.d0
            enddo
         enddo
      enddo
      do i3=0,nd3-1
         do i2=0,nd2-1
            do i1=0,nd1-1
               if (y(i1,i2,i3).lt.0.d0) then
                  y(i1,i2,i3)=0.d0
               endif
            enddo
         enddo
      enddo
      x_tot=0.d0
      y_tot=0.d0
      do i3=0,nd3-1
         do i2=0,nd2-1
            do i1=0,nd1-1
               x_tot=x_tot+x(i1,i2,i3)
               y_tot=y_tot+y(i1,i2,i3)
            enddo
         enddo
      enddo
      x_mean=x_tot/dble(nd1*nd2*nd3)
      y_mean=y_tot/dble(nd1*nd2*nd3)
      bias=y_mean-x_mean
      do i3=0,nd3-1
         do i2=0,nd2-1
            do i1=0,nd1-1
               y(i1,i2,i3)=y(i1,i2,i3)-bias
            enddo
         enddo
      enddo

      return
      end
