        subroutine fortrans(nd,nt,x,y)
c forward wavelet transform
c nd: length of data set
c nt length of data in data set to be transformed
c m filter length (m has to be even!)
c x input data, y output data
        implicit real*8 (a-h,o-z)
        dimension x(0:nd-1),y(0:nd-1)
c include the approriate filter coefficients
        include 'filters.inc'

        do 100,i=0,nt/2-1
        y(     i)=0.d0
        y(nt/2+i)=0.d0

        do 50,j=-m+1,m

c periodically wrap index if necessary
        ind=j+2*i
99      continue
        if (ind.lt.0) then
        ind=ind+nt
        goto 99
        endif
        if (ind.ge.nt) then
        ind=ind-nt
        goto 99
        endif

        y(     i)=y(     i)+cht(j)*x(ind)
        y(nt/2+i)=y(nt/2+i)+cgt(j)*x(ind)
50      continue

100     continue

        return
        end

C Identical to the homonymous subroutine of Goedecker (1998), except
C that additional .inc files are included through filters.inc.
