      subroutine fwt_3dsf(nd1,nd2,nd3,nt_min1,nt_min2,nt_min3,x,y)
C***********************************************************************

      integer   i1,
     +          i2,
     +          i3,
     +          nd1,
     +          nd2,
     +          nd3,
     +          nt1,
     +          nt2,
     +          nt3,
     +          nt_min1,
     +          nt_min2,
     +          nt_min3

      real*8    x(0:nd1-1,0:nd2-1,0:nd3-1),
     +          xx1(0:nd1-1),
     +          xx2(0:nd2-1),
     +          xx3(0:nd3-1),
     +          y(0:nd1-1,0:nd2-1,0:nd3-1),
     +          yy1(0:nd1-1),
     +          yy2(0:nd2-1),
     +          yy3(0:nd3-1)

C-----------------------------------------------------------------------

      nt1=nd1
      nt2=nd2
      nt3=nd3
      do i3=0,nt3-1
         do i2=0,nt2-1
            do i1=0,nt1-1
               xx1(i1)=x(i1,i2,i3)
            enddo
            call fortrans(nd1,nt1,xx1,yy1)
            do i1=0,nt1-1
               y(i1,i2,i3)=yy1(i1)
            enddo
         enddo
      enddo
      do i3=0,nt3-1
         do i1=0,nt1-1
            do i2=0,nt2-1
               xx2(i2)=y(i1,i2,i3)
            enddo
            call fortrans(nd2,nt2,xx2,yy2)
            do i2=0,nt2-1
               y(i1,i2,i3)=yy2(i2)
            enddo
         enddo
      enddo
      do i2=0,nt2-1
         do i1=0,nt1-1
            do i3=0,nt3-1
               xx3(i3)=y(i1,i2,i3)
            enddo
            call fortrans(nd3,nt3,xx3,yy3)
            do i3=0,nt3-1
               y(i1,i2,i3)=yy3(i3)
            enddo
         enddo
      enddo
      nt1=nt1/2
      nt2=nt2/2
      nt3=nt3/2
 1    if (nt1.ge.nt_min1.and.nt2.ge.nt_min2.and.nt3.ge.nt_min3) then
         do i3=0,nt3-1
            do i2=0,nt2-1
               do i1=0,nt1-1
                  xx1(i1)=y(i1,i2,i3)
               enddo
               call fortrans(nd1,nt1,xx1,yy1)
               do i1=0,nt1-1
                  y(i1,i2,i3)=yy1(i1)
               enddo
            enddo
         enddo
         do i3=0,nt3-1
            do i1=0,nt1-1
               do i2=0,nt2-1
                  xx2(i2)=y(i1,i2,i3)
               enddo
               call fortrans(nd2,nt2,xx2,yy2)
               do i2=0,nt2-1
                  y(i1,i2,i3)=yy2(i2)
               enddo
            enddo
         enddo
         do i2=0,nt2-1
            do i1=0,nt1-1
               do i3=0,nt3-1
                  xx3(i3)=y(i1,i2,i3)
               enddo
               call fortrans(nd3,nt3,xx3,yy3)
               do i3=0,nt3-1
                  y(i1,i2,i3)=yy3(i3)
               enddo
            enddo
         enddo
         nt1=nt1/2
         nt2=nt2/2
         nt3=nt3/2
         goto 1
      endif

      return
      end
