      subroutine denoise_sg3ds(cha_sd,cha_t,nd1,nd2,nd3,nt_min1,nt_min2,
     +                         nt_min3,c,sigma,t,x,y)
C***********************************************************************

      character*3
     +          cha_sd,
     +          cha_t

      integer   i1,
     +          i2,
     +          i3,
     +          nd1,
     +          nd2,
     +          nd3,
     +          nt_min1,
     +          nt_min2,
     +          nt_min3

      real*8    c,
     +          data(0:7*nd1*nd2*nd3/8-1),
     +          median,
     +          sigma,
     +          t,
     +          x(0:nd1-1,0:nd2-1,0:nd3-1),
     +          xy(0:nd1-1,0:nd2-1,0:nd3-1),
     +          y(0:nd1-1,0:nd2-1,0:nd3-1)

C-----------------------------------------------------------------------

      call fwt_3dsf(nd1,nd2,nd3,nt_min1,nt_min2,nt_min3,x,xy)
      if (cha_sd.eq.'ng') then
         do i3=0,nd3/2-1
            do i2=0,nd2/2-1
               do i1=nd1/2,nd1-1
                  data(i1+i2*nd1/2+i3*nd1*nd2/4-nd1/2)=
     +            abs(xy(i1,i2,i3))
               enddo
            enddo
         enddo
         do i3=0,nd3/2-1
            do i2=nd2/2,nd2-1
               do i1=0,nd1-1
                  data(i1+i2*nd1+i3*nd1*nd2/2-nd1*nd2/2+nd1*nd2*nd3/8)=
     +            abs(xy(i1,i2,i3))
               enddo
            enddo
         enddo
         do i3=nd3/2,nd3-1
            do i2=0,nd2-1
               do i1=0,nd1-1
                  data(i1+i2*nd1+i3*nd1*nd2-nd1*nd2*nd3/8)=
     +            abs(xy(i1,i2,i3))
               enddo
            enddo
         enddo
         sigma=1.d0/.6745d0*median(7*nd1*nd2*nd3/8,data)
      elseif (cha_sd.eq.'g') then
         sigma=1.d0
      endif
      if (cha_t.eq.'h') then
         t=sigma*sqrt(2.d0*log(dble(nd1*nd2*nd3)))
      elseif (cha_t.eq.'l') then
         if (nd1*nd2*nd3.le.32) then
            t=sigma*0.d0
         else
            t=sigma*(.3936d0+.1829d0*log(dble(nd1*nd2*nd3))/log(2.d0))
         endif
      endif
      do i3=0,nt_min3/2-1
         do i2=0,nt_min2/2-1
            do i1=nt_min1/2,nd1-1
               if (abs(xy(i1,i2,i3)).le.t) then
                  xy(i1,i2,i3)=c*xy(i1,i2,i3)
               endif
            enddo
         enddo
      enddo
      do i3=0,nt_min3/2-1
         do i2=nt_min2/2,nd2-1
            do i1=0,nd1-1
               if (abs(xy(i1,i2,i3)).le.t) then
                  xy(i1,i2,i3)=c*xy(i1,i2,i3)
               endif
            enddo
         enddo
      enddo
      do i3=nt_min3/2,nd3-1
         do i2=0,nd2-1
            do i1=0,nd1-1
               if (abs(xy(i1,i2,i3)).le.t) then
                  xy(i1,i2,i3)=c*xy(i1,i2,i3)
               endif
            enddo
         enddo
      enddo
      call fwt_3dsb(nd1,nd2,nd3,nt_min1,nt_min2,nt_min3,xy,y)

      return
      end
