      subroutine denoise_sp1d(cha_sd,cha_t,nd,nt_min,bias,c,sigma,t,x,y)
C***********************************************************************

      character*3
     +          cha_sd,
     +          cha_t

      integer   i,
     +          nd,
     +          nt_min

      real*8    bias,
     +          c,
     +          sigma,
     +          t,
     +          x(0:nd-1),
     +          x_mean,
     +          x_tot,
     +          xx(0:nd-1),
     +          y(0:nd-1),
     +          y_mean,
     +          y_tot

C-----------------------------------------------------------------------

      do i=0,nd-1
         xx(i)=2.d0*sqrt(x(i)+3.d0/8.d0)
      enddo
      call denoise_sg1d(cha_sd,cha_t,nd,nt_min,c,sigma,t,xx,y)
      do i=0,nd-1
         y(i)=1.d0/4.d0*y(i)**2-3.d0/8.d0
      enddo
      do i=0,nd-1
         if (y(i).lt.0.d0) then
            y(i)=0.d0
         endif
      enddo
      x_tot=0.d0
      y_tot=0.d0
      do i=0,nd-1
         x_tot=x_tot+x(i)
         y_tot=y_tot+y(i)
      enddo
      x_mean=x_tot/dble(nd)
      y_mean=y_tot/dble(nd)
      bias=y_mean-x_mean
      do i=0,nd-1
         y(i)=y(i)-bias
      enddo

      return
      end
