      subroutine fwt_3db(nd,nt_min,x,y)
C***********************************************************************

      integer   i,
     +          j,
     +          k,
     +          nd,
     +          nt,
     +          nt_min

      real*8    x(0:nd-1,0:nd-1,0:nd-1),
     +          xx(0:nd-1),
     +          y(0:nd-1,0:nd-1,0:nd-1),
     +          yy(0:nd-1)

C-----------------------------------------------------------------------

      nt=nt_min
      do k=0,nd-1
         do j=0,nd-1
            do i=0,nd-1
               y(i,j,k)=x(i,j,k)
            enddo
         enddo
      enddo
      do k=0,nt-1
         do j=0,nt-1
            do i=0,nt-1
               xx(i)=x(i,j,k)
            enddo
            call backtrans(nd,nt,xx,yy)
            do i=0,nt-1
               y(i,j,k)=yy(i)
            enddo
         enddo
      enddo
      do k=0,nt-1
         do i=0,nt-1
            do j=0,nt-1
               xx(j)=y(i,j,k)
            enddo
            call backtrans(nd,nt,xx,yy)
            do j=0,nt-1
               y(i,j,k)=yy(j)
            enddo
         enddo
      enddo
      do j=0,nt-1
         do i=0,nt-1
            do k=0,nt-1
               xx(k)=y(i,j,k)
            enddo
            call backtrans(nd,nt,xx,yy)
            do k=0,nt-1
               y(i,j,k)=yy(k)
            enddo
         enddo
      enddo
      nt=nt*2
 1    if (nt.le.nd) then
         do k=0,nt-1
            do j=0,nt-1
               do i=0,nt-1
                  xx(i)=y(i,j,k)
               enddo
               call backtrans(nd,nt,xx,yy)
               do i=0,nt-1
                  y(i,j,k)=yy(i)
               enddo
            enddo
         enddo
         do k=0,nt-1
            do i=0,nt-1
               do j=0,nt-1
                  xx(j)=y(i,j,k)
               enddo
               call backtrans(nd,nt,xx,yy)
               do j=0,nt-1
                  y(i,j,k)=yy(j)
               enddo
            enddo
         enddo
         do j=0,nt-1
            do i=0,nt-1
               do k=0,nt-1
                  xx(k)=y(i,j,k)
               enddo
               call backtrans(nd,nt,xx,yy)
               do k=0,nt-1
                  y(i,j,k)=yy(k)
               enddo
            enddo
         enddo
         nt=nt*2
         goto 1
      endif

      return
      end
