        parameter(m=6)
        dimension ch(-m:m),cg(-m:m),cht(-m:m),cgt(-m:m)

c******** coefficients for wavelet transform *********************
        do i=-m,m
        ch(i)=0.d0
        cht(i)=0.d0
        cg(i)=0.d0
        cgt(i)=0.d0
        enddo

c h coefficients
        ch( -4)=.03782845550726d0
        ch( -3)=-.02384946501956d0
        ch( -2)=-.11062440441844d0
        ch( -1)=.37740285561283d0
        ch(  0)=.85269867900889d0
        ch(  1)=.37740285561283d0
        ch(  2)=-.11062440441844d0
        ch(  3)=-.02384946501956d0
        ch(  4)=.03782845550726d0
c
        cht(-3)=-.06453888262870d0
        cht(-2)=-.04068941760916d0
        cht(-1)=.41809227322162d0
        cht( 0)=.78848561640558d0
        cht( 1)=.41809227322162d0
        cht( 2)=-.04068941760916d0
        cht( 3)=-.06453888262870d0

c g coefficients from h coefficients
        do i=-m,m-1
        cg(i+1)=cht(-i)*(-1)**(i+1)
        cgt(i+1)=ch(-i)*(-1)**(i+1)
        enddo

C Analogous to the lazy4.inc file, but the h coefficients are deduced
C from the MATLAB Wavelet Toolbox [with appropriate normalization =
C +sqrt(2.d0)]: format long, [cht,ch] = wfilters('rbio4.4','l').
